#coding:utf-8
import os
import sys
import logging
from ConfigParser import ConfigParser


def main():
    parser = ConfigParser()
    parser.read(sys.argv[1])

    log_level = parser.get('msgserver', 'LOG_LEVEL')
    logging.getLogger().setLevel(log_level)

    rabbit_host = parser.get('msgserver', 'rabbitmq')

    handlers = parser.options('handlers')
    handlers_dict = {}
    for queue in handlers:
        class_name = parser.get('handlers', queue)
        handlers_dict[queue] = class_name

    params = {
        'socket_url': parser.get('msgserver', 'url'),
        'socket_port': parser.get('msgserver', 'port'),
        'socket_router_name': parser.get('msgserver', 'router'),

        'session_engine': parser.get('msgserver', 'session'),
        'cookie_session_key': parser.get('msgserver', 'cookie_session_key'),

        'database_engine': parser.get('database', 'DATABASE_ENGINE'),
        'database_name': parser.get('database', 'DATABASE_NAME'),
        'database_host': parser.get('database', 'DATABASE_HOST'),
        'database_port': parser.get('database', 'DATABASE_PORT'),
        'database_user': parser.get('database', 'DATABASE_USER'),
        'database_password': parser.get('database', 'DATABASE_PASSWORD'),

        'cache_host': parser.get('runtime', 'CACHE_BACKEND'),
    }
    from msgserver.app import run
    run(rabbit_host, handlers_dict, params)


if __name__ == "__main__":
    # добавляем в sys.path путь до текущей папки
    project_path = os.path.dirname(__file__)
    sys.path.insert(0, os.path.join(project_path, '../'))
    if len(sys.argv) != 2:
        print u'usage: runserver.py path_to_msgserver_conf'
        sys.exit()
    else:
        main()
